#
# Conditional build
%bcond_without	static_libs	# static library
%bcond_without	doc		# HTML and man docs
%bcond_without	tests		# unit tests

Summary:	Font configuration and customization tools
Summary(pl.UTF-8):	Narzędzia do konfigurowania fontów
Summary(pt_BR.UTF-8):	Ferramentas para configuração e customização do acesso a fontes
Name:		fontconfig
Version:	2.16.1
Release:	1
Epoch:		1
License:	MIT
Group:		Libraries
# up to 2.16.0:
#Source0:	https://www.freedesktop.org/software/fontconfig/release/%{name}-%{version}.tar.xz
# now at gitlab only
#Source0Download: https://gitlab.freedesktop.org/fontconfig/fontconfig/-/releases
Source0:	https://gitlab.freedesktop.org/api/v4/projects/890/packages/generic/fontconfig/%{version}/%{name}-%{version}.tar.xz
# Source0-md5:	57f386865c0e06825b2b564754f22b88
Source1:	%{name}-lcd-filter.conf
Patch0:		%{name}-bitstream-cyberbit.patch
Patch1:		disable-tests.patch
URL:		http://fontconfig.org/
BuildRequires:	autoconf >= 2.71
BuildRequires:	automake >= 1:1.11
%{?with_tests:BuildRequires:	bubblewrap}
%if %{with doc}
BuildRequires:	docbook-dtd31-sgml
BuildRequires:	docbook-dtd41-sgml
BuildRequires:	docbook-utils >= 0.6.13-3
%endif
BuildRequires:	ed
BuildRequires:	expat-devel
# pkgconfig(freetype) >= 21.0.15
BuildRequires:	freetype-devel >= 1:2.9
BuildRequires:	gettext-tools >= 0.19.8
BuildRequires:	gperf
%{?with_tests:BuildRequires:	json-c-devel}
BuildRequires:	libtool >= 2:2.2
BuildRequires:	libuuid-devel
BuildRequires:	pkgconfig
%{?with_doc:BuildRequires:	python3}
BuildRequires:	rpmbuild(macros) >= 2.036
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Fontconfig is designed to locate fonts within the system and select
them according to requirements specified by applications.

This package contains tools and documentation.

%description -l pl.UTF-8
Fontconfig jest biblioteką przeznaczoną do lokalizowania fontów w
systemie i wybierania ich w zależności od potrzeb aplikacji.

Paket ten zawiera programy narzędziowe i dokumentację.

%description -l pt_BR.UTF-8
Fontconfig é uma biblioteca para configuração e customização do acesso
a fontes.

Este pacote contém as ferramentas e documentação.

%package libs
Summary:	Font configuration and customization library
Summary(pl.UTF-8):	Biblioteka do konfigurowania fontów
Summary(pt_BR.UTF-8):	Biblioteca para configuração e customização do acesso a fontes
Group:		Libraries
Requires:	freetype >= 1:2.9
Provides:	XFree86-fontconfig
Obsoletes:	XFree86-fontconfig < 4.4
Conflicts:	fontconfig <= 1:2.2.98-1

%description libs
Fontconfig is designed to locate fonts within the system and select
them according to requirements specified by applications.

%description libs -l pl.UTF-8
Fontconfig jest biblioteką przeznaczoną do lokalizowania fontów w
systemie i wybierania ich w zależności od potrzeb aplikacji.

%description libs -l pt_BR.UTF-8
Fontconfig é uma biblioteca para configuração e customização do acesso
a fontes.

%package devel
Summary:	Font configuration and customization library - development files
Summary(pl.UTF-8):	Biblioteka do konfigurowania fontów - pliki dla programistów
Summary(pt_BR.UTF-8):	Biblioteca para configuração e customização do acesso a fontes - arquivos de desenvolvimento
Group:		Development/Libraries
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}
Requires:	expat-devel
Requires:	freetype-devel >= 1:2.9
Requires:	libuuid-devel
Provides:	XFree86-fontconfig-devel
Obsoletes:	XFree86-fontconfig-devel < 4.4

%description devel
Fontconfig is designed to locate fonts within the system and select
them according to requirements specified by applications.

This package contains the header files needed to develop programs that
use these fontconfig.

%description devel -l pl.UTF-8
Fontconfig jest biblioteką przeznaczoną do lokalizowania fontów w
systemie i wybierania ich w zależności od potrzeb aplikacji.

Ten pakiet zawiera pliki nagłówkowe potrzebne do kompilowania
programów korzystających z biblioteki fontconfig.

%description devel -l pt_BR.UTF-8
Fontconfig é uma biblioteca para configuração e customização do acesso
a fontes.

Este pacote contém arquivos de desenvolvimento necessários à criação
de extensões baseadas na biblioteca fontconfig.

%package static
Summary:	Static font configuration and customization library
Summary(pl.UTF-8):	Statyczna biblioteka do konfigurowania fontów
Summary(pt_BR.UTF-8):	Biblioteca estática para configuração e customização do acesso a fontes
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}
Provides:	XFree86-fontconfig-static
Obsoletes:	XFree86-fontconfig-static < 4.4

%description static
This package contains static version of fontconfig library.

%description static -l pl.UTF-8
Ten pakiet zawiera statyczną wersję biblioteki fontconfig.

%description static -l pt_BR.UTF-8
Este pacote contém a biblioteca estática do fontconfig

%prep
%setup -q
%patch -P0 -p1
%patch -P1 -p1

# bwrap: No permissions to creating new namespace, likely because the kernel does not allow non-privileged user namespaces...
sed -i -e 's#BWRAP=.*#BWRAP=#g' test/run-test.sh

%build
%{__gettextize -d po-conf}
%{__gettextize}
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}

# don't rebuild docs by default, use prebuild ones
export HASDOCBOOK=no

%configure \
	--enable-docs%{!?with_doc:=no} \
	--disable-silent-rules \
	--%{?with_static_libs:en}%{!?with_static_libs:dis}able-static
%{__make}

%{?with_tests:%{__make} OSTYPE=linux check || (cat test/test-suite.log && /bin/false)}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_mandir}/man{1,3,5},/var/cache/fontconfig} \

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	htmldoc_DATA= \
	doc_DATA=

install %{SOURCE1} \
	$RPM_BUILD_ROOT%{_datadir}/%{name}/conf.avail/10-lcd-filter.conf

ln -s %{_datadir}/%{name}/conf.avail $RPM_BUILD_ROOT%{_sysconfdir}/fonts/conf.avail

cp -pf conf.d/README README.confd

%find_lang %{name}
%find_lang %{name}-conf -a %{name}.lang

%clean
rm -rf $RPM_BUILD_ROOT

%pretrans
# this needs to be a symlink
if [ -d %{_sysconfdir}/fonts/conf.avail ] && [ ! -L %{_sysconfdir}/fonts/conf.avail ]; then
	mv -f %{_sysconfdir}/fonts/conf.avail{,.rpmsave}
	install -d %{_datadir}/%{name}/conf.avail
	ln -s %{_datadir}/%{name}/conf.avail %{_sysconfdir}/fonts/conf.avail
	mv -f %{_sysconfdir}/fonts/conf.avail.rpmsave/*.conf %{_sysconfdir}/fonts/conf.avail/
	rmdir %{_sysconfdir}/fonts/conf.avail.rpmsave 2>/dev/null || :
fi

%post
umask 022
HOME=/tmp %{_bindir}/fc-cache -f 2>/dev/null || :

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc AUTHORS COPYING NEWS README.md README.confd doc/fontconfig-user.html
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/fonts/fonts.conf
%{_sysconfdir}/fonts/conf.avail
%{_sysconfdir}/fonts/conf.d/README
%config(noreplace,missingok) %verify(not link md5 mtime size) %{_sysconfdir}/fonts/conf.d/*.conf
%attr(755,root,root) %{_bindir}/fc-cache
%attr(755,root,root) %{_bindir}/fc-cat
%attr(755,root,root) %{_bindir}/fc-conflist
%attr(755,root,root) %{_bindir}/fc-list
%attr(755,root,root) %{_bindir}/fc-match
%attr(755,root,root) %{_bindir}/fc-query
%attr(755,root,root) %{_bindir}/fc-pattern
%attr(755,root,root) %{_bindir}/fc-scan
%attr(755,root,root) %{_bindir}/fc-validate
%dir %{_datadir}/xml/%{name}
%{_datadir}/xml/%{name}/fonts.dtd
%{_datadir}/%{name}/conf.avail/*.conf
%if %{with doc}
%{_mandir}/man1/fc-*.1*
%{_mandir}/man5/fonts-conf.5*
%endif
%dir /var/cache/fontconfig

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfontconfig.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libfontconfig.so.1

%files devel
%defattr(644,root,root,755)
%doc doc/fontconfig-devel.html
%attr(755,root,root) %{_libdir}/libfontconfig.so
%{_libdir}/libfontconfig.la
%{_includedir}/fontconfig
%{_pkgconfigdir}/fontconfig.pc
%{_datadir}/gettext/its/fontconfig.its
%{_datadir}/gettext/its/fontconfig.loc
%if %{with doc}
%{_mandir}/man3/Fc*.3*
%endif

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libfontconfig.a
%endif
%changelog
* Sun Mar 23 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fontconfig.git;a=log;h=master

* Sun Mar 23 2025 Jakub Bogusz <qboosh@pld-linux.org> 74610c2
- updated to 2.16.1

* Sun Jan 19 2025 Jakub Bogusz <qboosh@pld-linux.org> f3e6e1e
- use patch -P

* Sun Jan 19 2025 Jan Palus <atler@pld-linux.org> 1064414
- up to 2.16.0

* Sat Dec 23 2023 Jan Palus <atler@pld-linux.org> ee94d77
- up to 2.15.0

* Sun Nov 26 2023 Jan Rękorajski <baggins@pld-linux.org> cd28cb1
- Release 2 (by relup.sh)

* Fri Jan 27 2023 Jan Palus <atler@pld-linux.org> 248fe7b
- up to 2.14.2

* Sat Oct 22 2022 Jakub Bogusz <qboosh@pld-linux.org> f97a4e5
- versioned Obsoletes

* Sat Oct 22 2022 Jan Palus <atler@pld-linux.org> cd3e83c
- up to 2.14.1

* Thu Apr 07 2022 Jan Palus <atler@pld-linux.org> e129e34
- disable test which requires network access

* Thu Apr 07 2022 Jan Palus <atler@pld-linux.org> d96ee8f
- BR: bubblewrap for tests; rel 2

* Thu Apr 07 2022 Jan Palus <atler@pld-linux.org> caff1e1
- up to 2.14.0

* Thu Dec 19 2019 Jan Palus <atler@pld-linux.org> 350d98e
- real solution for missing FT_Done_MM_Var symbol; rel 4

* Wed Dec 18 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 8c8cfad
- rel 3; disable tests using bwrap

* Wed Dec 18 2019 Elan Ruusamäe <glen@pld-linux.org> 34d0d81
- Release 2 to rebuild to fix missing FT_Done_MM_Var symbol

* Sun Sep 02 2018 Jakub Bogusz <qboosh@pld-linux.org> f14aacd
- updated freetype and libuuid dependencies; tests use json-c

* Sat Sep 01 2018 Jan Palus <atler@pld-linux.org> d8cf30e
- up to 2.13.1

* Wed Mar 14 2018 Jan Palus <atler@pld-linux.org> a0282ae
- add another patch to fix weight without explicit attribute; rel 3

* Sun Mar 11 2018 Jan Palus <atler@pld-linux.org> 1e37af2
- keep cat of test log but make sure build fails on test failure

* Sun Mar 11 2018 Jan Palus <atler@pld-linux.org> daca2f4
- temporarily enable showing test/test-suite.log on test failure

* Sat Mar 10 2018 Jan Palus <atler@pld-linux.org> 224401c
- patch to fix constant (non-ranged) weight in font pattern; rel 2

